package IRed.spectro.stamped;

import java.io.DataOutputStream;
import java.io.IOException;

public class StringType extends DataType {

	public StringType () {
		super(1);
	}

	private StringType (StringType orig) {
		super(orig);
	}

	public boolean assignable(DataType rhs) {
		return rhs instanceof StringType;
	}

	public DataType clone() {
		return new StringType(this);
	}

   public boolean equals(Object o) {
      return o instanceof StringType;
   }

	public DataType resolveType() {return this;}

	public void dump(String left) {
		System.out.println(left + "String");
	}

   public void dumpBinary(DataOutputStream out) throws IOException {
      out.writeInt(Tag.STRING);
   }

}
